/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 

package ch.educeth.eccapplet;

import javax.swing.*;
import java.awt.*;

/** 
 * Stellt die den Teil der Codierung innerhalb des 'mathematischen
 * Teils dar */
public class EccMathCoding extends JPanel {
	private Font BOLD_FONT = new Font("SansSerif", Font.BOLD, 12);
	private Font PLAIN_FONT = new Font("Monospaced", Font.PLAIN, 12);
	private JButton button;

	public  EccMathCoding() {
		this.setMaximumSize(new Dimension(1000, 180));
		this.setPreferredSize(new Dimension(300, 180));
	}
		
	public void paint(Graphics g) {
		super.paint(g);
		int dim = EccController.CONTROLLER.ecmo.getNumOfDim();
		int[] col1, col2, col3, col4;
		int xTrans;
		/* Berechnen der Abstaende zwischen den einzelnen Komponenten */
		if (this.getSize().width < 250) {
			xTrans = 0;
		} else {
			xTrans = (int)((this.getSize().width - 250)*0.38197);
		}
		col1 = new int[dim];		
		col2 = new int[dim];
		col3 = new int[dim];
		col4 = new int[dim];
		String str1 = "", str2 = "";
		Color color = new Color(0,0,0);
		g.setFont(BOLD_FONT);
		g.setColor(Color.black);
		/* Block: Codierung */
		g.drawString(EccConstants.CODING, 10 + xTrans, 20);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(1);
		g.setColor(color);
		g.drawString("00", 40 + xTrans, 40);
		g.setColor(Color.black);
		g.drawString(EccConstants.ARROW, 60 + xTrans, 40);
		color = EccController.CONTROLLER.ecmo.getHyperOriginalColor(1);
		if (similarColors(color)) {
			int re = color.getRed();
			int gr = color.getGreen();
			int bl = color.getBlue();
			Color darkerColor = new Color(re - 15, gr - 15, bl - 15);
			color = darkerColor;
		}																						
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(0, i);
			str1 += String.valueOf(temp);
			col1[i] = temp;
		}							
		g.setColor(color);
		g.drawString(str1, 90 + xTrans, 40);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(2);
		g.setColor(color);
		str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(1, i);
			str1 += String.valueOf(temp);
			col2[i] = temp;
		}
		g.drawString("01", 40 + xTrans, 60);
		g.setColor(Color.black);
		g.drawString(EccConstants.ARROW, 60 + xTrans, 60);
		color = EccController.CONTROLLER.ecmo.getHyperOriginalColor(2);
		if (similarColors(color)) {
			int re = color.getRed();
			int gr = color.getGreen();
			int bl = color.getBlue();
			Color darkerColor = new Color(re - 15, gr - 15, bl - 15);
			color = darkerColor;
		}
		g.setColor(color);
		g.drawString(str1, 90 + xTrans, 60);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(3);
		g.setColor(color);
		g.drawString("10", 40 + xTrans, 80);
		g.setColor(Color.black);
		g.drawString(EccConstants.ARROW, 60 + xTrans, 80);
		color = EccController.CONTROLLER.ecmo.getHyperOriginalColor(3);		
		if (similarColors(color)) {
			int re = color.getRed();
			int gr = color.getGreen();
			int bl = color.getBlue();
			Color darkerColor = new Color(re - 15, gr - 15, bl - 15);
			color = darkerColor;
		}	
		str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(2, i);
			str1 += String.valueOf(temp);
			col3[i] = temp;
		}
		g.setColor(color);
		g.drawString(str1, 90 + xTrans, 80);
		color = EccController.CONTROLLER.ecmo.getOriginalColor(4);
		g.setColor(color);
		g.drawString("11", 40 + xTrans, 100);
		g.setColor(Color.black);
		g.drawString(EccConstants.ARROW, 60 + xTrans, 100);
		color = EccController.CONTROLLER.ecmo.getHyperOriginalColor(4);
		if (similarColors(color)) {
			int re = color.getRed();
			int gr = color.getGreen();
			int bl = color.getBlue();
			Color darkerColor = new Color(re - 15, gr - 15, bl - 15);
			color = darkerColor;
		}
		str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(3, i);
			str1 += String.valueOf(temp);
			col4[i] = temp;
		}
		g.setColor(color);
		g.drawString(str1, 90 + xTrans, 100);
		g.setColor(Color.black);
		/* Block: Generatormatrix */
		if (EccController.CONTROLLER.ecmo.getGeneratorFlag()) {
			g.setFont(PLAIN_FONT);
			g.setColor(Color.black);
			g.drawString(EccConstants.GENERATOR, 10 + xTrans, 130);
			String str20 = "", str21 = "";
			if (EccController.CONTROLLER.ecmo.getModifiedFlag()) {
				str20 = EccController.CONTROLLER.ecmo.getFirstString();
				str21 = EccController.CONTROLLER.ecmo.getSecondString();
			} else if (dim == 13) {
				str20 = EccColorModel.GENERATOR131;
				str21 = EccColorModel.GENERATOR132;
			} else if (dim == 7) {
				str20 = EccColorModel.GENERATOR71;
				str21 = EccColorModel.GENERATOR72;
			} else if (dim == 6) {
				str20 = EccColorModel.GENERATOR61;
				str21 = EccColorModel.GENERATOR62;
			} else if (dim == 5) {
			str20 = EccColorModel.GENERATOR51;
				str21 = EccColorModel.GENERATOR52;
			} else if (dim == 4) {
				str20 = EccColorModel.GENERATOR41;
				str21 = EccColorModel.GENERATOR42;
			} else if (dim == 3) {
				str20 = EccColorModel.GENERATOR31;
				str21 = EccColorModel.GENERATOR32;
			} else {
				System.err.println("error in EccMathCoding.paint()");
			}
			g.drawString(str20, 70 + xTrans, 150);			
			g.drawString(str21, 70 + xTrans, 165);
			g.drawString("G =", 40 + xTrans, 156);
			g.drawLine(66 + xTrans, 140, 66 + xTrans, 167);
			g.drawLine(66 + xTrans, 140, 68 + xTrans, 140);
			g.drawLine(66 + xTrans, 167, 68 + xTrans, 167);
			g.setFont(BOLD_FONT);
			FontMetrics fm1=g.getFontMetrics(BOLD_FONT);
			int fontWi = fm1.stringWidth(str20);
			g.drawLine(73+fontWi + xTrans, 140, 73+fontWi + xTrans, 167);
			g.drawLine(71+fontWi + xTrans, 140, 73+fontWi + xTrans, 140);
			g.drawLine(71+fontWi + xTrans, 167, 73+fontWi + xTrans, 167);		
		}		
	}	/* paint */

	/**
	 * Zeigt ob die Farbe aehnlich der Hintergrundfarbe des Panels ist
	 * @param color Farbe die verglichen werden soll
	 * @return true, falls die beiden Farben aehnlich sind
	 */
	public boolean similarColors(Color color) {
		int sum;
		sum = Math.abs(this.getBackground().getRed() - color.getRed()) +
				Math.abs(this.getBackground().getGreen() - color.getGreen()) +
				Math.abs(this.getBackground().getBlue() - color.getBlue());
		if (sum < 14) {
			return true;
		} else {
			return false;
		}
	}	/* similarColors */

}
