/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 

package ch.educeth.eccapplet;

import javax.swing.*;
import java.awt.*;


/**
 * Stellt den Distanzteil innerhalb des 'mathematischen' Teils dar
 */
public class EccMathDistance extends JPanel {
	private Font BOLD_FONT = new Font("SansSerif", Font.BOLD, 12);
	private Font PLAIN_FONT = new Font("Monospaced", Font.PLAIN, 12);

	public  EccMathDistance() {
		this.setMaximumSize(new Dimension(1000, 70));
		this.setPreferredSize(new Dimension(300, 70));
	}

	public void paint(Graphics g) {
		super.paint(g);
		int dim = EccController.CONTROLLER.ecmo.getNumOfDim();
		int[] col1 = new int[dim];		
		int[] col2 = new int[dim];
		int[] col3 = new int[dim];
		int[] col4 = new int[dim];
		String str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(0, i);
			str1 += String.valueOf(temp);
			col1[i] = temp;
		}							
		str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(1, i);
			str1 += String.valueOf(temp);
			col2[i] = temp;
		}
		str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(2, i);
			str1 += String.valueOf(temp);
			col3[i] = temp;
		}
		str1 = "";
		for (int i=0; i < dim; i++) {
			int temp = EccController.CONTROLLER.ecmo.getMatrixAt(3, i);
			str1 += String.valueOf(temp);
			col4[i] = temp;
		}
		int temp1 = calculateDistance(dim, col1, col2, col3, col4);
		/* Block: minimale Distanz */
		g.setFont(BOLD_FONT);
		String str2 = "";
		int xTrans = 0;
		if (this.getSize().width < 250) {
			xTrans = 0;
		} else {
			xTrans = (int)((this.getSize().width - 250)*0.38197);
		}
		str2 = EccConstants.MIN_DIST + String.valueOf(temp1);
		g.drawString(str2, 10 + xTrans, 20);
		g.setFont(PLAIN_FONT);
		String str12 = EccConstants.CODE_RECOGNIZE;
		if (temp1 > 0) {
			str12 += String.valueOf(temp1 - 1);
		} else {
			str12 += "0";
		}
		str12 += EccConstants.ERROR;
		g.drawString(str12, 10 + xTrans, 40);
		String str13 = EccConstants.CODE_CORRECTS;
		if (temp1 == 0) {
			str13 += "0";
		} else if ((temp1 % 2) == 0) {
			str13 += String.valueOf((temp1 - 2)/2);
		} else {
			str13 += String.valueOf((temp1 - 1)/2);
		}
		str13 += EccConstants.ERROR;
		g.drawString(str13, 10 + xTrans, 60);
	}	/* paint */

	/**
	 * Berechnet die minimale Distanz zwischen vier Binaerzahlen
	 * @param dim Laenge der Binaerzahlen
	 * @param a,b,c,d Binaerzahlen
	 * @return minimale Distanz
	 */
	public int calculateDistance (int dim, int[] a, int[] b, int[] c, int[] d) {
		int min = 99, sum = 0, msg = 0;
		for (int i=0; i < dim; i++) {
			if (a[i] != b[i]) {
				sum++;
			}
		}
		min = sum;
		sum = 0;
		for (int i=0; i < dim; i++) {
			if (a[i] != c[i]) {
				sum++;
			}
		}
		if (sum < min) {
			min = sum;
		}
		sum = 0;
		for (int i=0; i < dim; i++) {
			if (a[i] != d[i]) {
				sum++;
			}
		}
		if (sum < min) {
			min = sum;
		}
		sum = 0;
		for (int i=0; i < dim; i++) {
			if (b[i] != c[i]) {
				sum++;
			}
		}
		if (sum < min) {
			min = sum;
		}
		sum = 0;
		for (int i=0; i < dim; i++) {
			if (b[i] != d[i]) {
				sum++;
			}
		}
		if (sum < min) {
			min = sum;
		}
		sum = 0;
		for (int i=0; i < dim; i++) {
			if (c[i] != d[i]) {
				sum++;
			}
		}
		if (sum < min) {
			min = sum;
		}
		sum = 0;
		return min;
	}	/* calculateDistance */	

}
