/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 

package ch.educeth.eccapplet;

import javax.swing.*;
import java.awt.*;


/**
 * Stellt den Beispielpunkt im 'mathematischen' Teil dar
 */
public class EccMathPoint extends JPanel {
	private Font BOLD_FONT = new Font("SansSerif", Font.BOLD, 12);
	private Font PLAIN_FONT = new Font("Monospaced", Font.PLAIN, 12);
	private int x1 = 0, y1 = 0;

	public  EccMathPoint() {
		this.setMaximumSize(new Dimension(1000, 110));
		this.setPreferredSize(new Dimension(300, 110));
	}
	
	public void paint(Graphics g) {
		super.paint(g);
		/* Block: Anzahl Fehler */
		int xTrans = 0;
		if (this.getSize().width < 250) {
			xTrans = 0;
		} else {
			xTrans = (int)((this.getSize().width - 250)*0.38197);
		}
		int dim = EccController.CONTROLLER.ecmo.getNumOfDim();
		/* Block: Beispielpunkt */
		g.setFont(BOLD_FONT);
		g.drawString(EccConstants.EXAMPLE_POINT, 10 + xTrans, 20);
		g.setFont(PLAIN_FONT);
		String str7 = EccConstants.ORIGINAL_POINT;
		int pp = EccController.CONTROLLER.empi.getPicturePoint(x1, y1) - 1;
		int[] bin = new int[2];
		EccController.CONTROLLER.ecmo.getBinary(pp, bin, 2);
		str7 += bin[0];
		str7 += bin[1];
		g.drawString(str7, 10 + xTrans, 40); 
		String str8 = EccConstants.CODED_VALUE;
		for (int i = 0; i < dim; i++) {
			str8 += EccController.CONTROLLER.ecmo.getMatrixAt(pp, i);
		}
		g.drawString(str8, 10 + xTrans, 60);
		String str9 = EccConstants.RECEIVED_VALUE;
		int epp = EccController.CONTROLLER.empi.getErrorPicturePoint(x1, y1);
		int[] binary = new int[dim];
		EccController.CONTROLLER.ecmo.getBinary(epp, binary, dim);
		FontMetrics fm=g.getFontMetrics(PLAIN_FONT);
		g.drawString(str9, 10 + xTrans, 80);
		int wi = fm.stringWidth(str9);
		for (int i = 0; i < dim; i++) {
			if (binary[i] != EccController.CONTROLLER.ecmo.getMatrixAt(pp, i)) {
				g.setColor(Color.red);
				g.drawString(String.valueOf(binary[i]), 10 + wi + xTrans, 80);
				wi += fm.charWidth('0');
			} else {
				g.setColor(Color.black);
				g.drawString(String.valueOf(binary[i]), 10 + wi + xTrans, 80);
				wi += fm.charWidth('0');
			}
		}
		g.setColor(Color.black);
		String str10 = EccConstants.DECODED_VALUE;
		g.drawString(str10, 10 + xTrans, 100);
		Color dp = EccController.CONTROLLER.empi.getDecodedPicturePoint(x1, y1);
		String str11 = "";
		if (dp.equals(EccController.CONTROLLER.ecmo.getOriginalColor(1))) {
			str11 = "00";
			if ((bin[0] != 0) || (bin[1] != 0)) {
				g.setColor(Color.red);
			}
		} else if (dp.equals(EccController.CONTROLLER.ecmo.getOriginalColor(2))) {
			str11 = "01";
			if ((bin[0] != 0) || (bin[1] != 1)) {
				g.setColor(Color.red);
			}
		} else if (dp.equals(EccController.CONTROLLER.ecmo.getOriginalColor(3))) {
			str11 = "10";
			if ((bin[0] != 1) || (bin[1] != 0)) {
				g.setColor(Color.red);
			}
		} else if (dp.equals(EccController.CONTROLLER.ecmo.getOriginalColor(4))) {
			str11 = "11";
			if ((bin[0] != 1) || (bin[1] != 1)) {
				g.setColor(Color.red);
			}

		}
		int tr = fm.stringWidth(str10);
		g.drawString(str11, 10 + tr + xTrans, 100);
		g.setColor(Color.black);
	}	/* paint */

}
