/* This file is part of Error Correctiong Codes Application.
 *
 * Ecc-Application is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Ecc-Application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Ecc-Application; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */


package ch.educeth.eccapplet;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

		
/**
 * Panel welches die Eigenschaften der Fehler korrigierenden Codes mathematisch
 * darstellt.
 */
public class EccRightMath extends JPanel {
	protected JButton button;
	private EccMathCoding emc;
	private EccMathDistance emd;
	private EccMathError eme;
	private EccMathPoint emp;

	public EccRightMath() {
		super();
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		emc = new EccMathCoding();
		emc.setAlignmentX(CENTER_ALIGNMENT);
		this.add(emc);
		button = new JButton("Generatormatrix ndern");
		button.setAlignmentX(CENTER_ALIGNMENT);
		this.add(button);
		this.add(Box.createVerticalGlue());
		emd = new EccMathDistance();
		emd.setAlignmentX(CENTER_ALIGNMENT);
		this.add(emd);
		this.add(Box.createVerticalGlue());
		eme = new EccMathError();
		eme.setAlignmentX(CENTER_ALIGNMENT);
		this.add(eme);
		this.add(Box.createVerticalGlue());
		emp = new EccMathPoint();
		emp.setAlignmentX(CENTER_ALIGNMENT);
		this.add(emp);
	}

	/**
	 * Hinzufuegen eines ActionListeners
	 */
	public void addMathButtonListener(ActionListener a) {
		button.addActionListener(a);
	}
	
}
